﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolTip;

namespace CustomToolTip119702
{
    public partial class Form1 : Form, IUIElementCreationFilter
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = myData();
            //this.ultraGrid1.CreationFilter = this;
        }

        private object myData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("DropDown Column", typeof(string));


            for (int i = 0; i < 30; i++)
            {
                dt.Rows.Add("The quick brown fox jumps over the lazy dogs.");
            }

            return dt;
        }

        //Change Appearnce using a Creation Filter
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            CellUIElement cellUIElement = parent as CellUIElement;

            if (cellUIElement != null && cellUIElement.ToolTipItem != null)
            {
                if (!(cellUIElement.ToolTipItem is MyToolTipItem))
                {
                    MyToolTipItem toolTipItem = new MyToolTipItem();
                    toolTipItem.OriginalToolTipItem = cellUIElement.ToolTipItem;
                    cellUIElement.ToolTipItem = toolTipItem;
                }
            }
        }

        public class MyToolTipItem : IToolTipItem
        {
            public IToolTipItem OriginalToolTipItem { get; set; }

            public ToolTipInfo GetToolTipInfo(Point mousePosition, UIElement element, UIElement previousToolTipElement, ToolTipInfo toolTipInfoDefault)
            {
                toolTipInfoDefault = OriginalToolTipItem.GetToolTipInfo(mousePosition, element, previousToolTipElement,
                                                                        toolTipInfoDefault);
                toolTipInfoDefault.BackColor = Color.Red;
                toolTipInfoDefault.BorderStyle = ToolTipBorderStyle.Raised;
                
                toolTipInfoDefault.DisplayStyle = ToolTipDisplayStyle.Standard;
                return toolTipInfoDefault;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //TO CANCEL DEFAULT TOOLTIP
            //e.Layout.Override.TipStyleCell = Infragistics.Win.UltraWinGrid.TipStyle.Hide;
           
        }

        //CUSTOM TOOLTIP
        UltraToolTipInfo info = new UltraToolTipInfo();
        private void ultraGrid1_MouseEnterElement(object sender, UIElementEventArgs e)
        {
            if (e.Element is CellUIElement)
            {
                info.ToolTipText = ((CellUIElement)e.Element.GetAncestor(typeof(CellUIElement))).Cell.Text;
                ultraToolTipManager1.DisplayStyle = ToolTipDisplayStyle.BalloonTip;
                ultraToolTipManager1.SetUltraToolTip(ultraGrid1, info);
                ultraToolTipManager1.ShowToolTip(ultraGrid1, Cursor.Position);
                ultraToolTipManager1.Appearance.ForeColor = Color.White;    
                ultraToolTipManager1.Appearance.BackColor = Color.Black;
                ultraToolTipManager1.Appearance.BorderColor = Color.Red;
               
            }
           
        }
    }
}
